<script lang="ts">
  import { createEventDispatcher } from "svelte";
  const dispatch = createEventDispatcher();
  import { getNotificationsContext } from 'svelte-notifications';

  const { addNotification } = getNotificationsContext();
  import { Input, Label } from "@sveltestrap/sveltestrap";

  export let options: string[] = [];
  export let value: string[] = [];
  export let label: string;
  export let max = 0;

  function onChange(evt: {target: {checked: boolean}}, option: string) {
    const checked = evt.target.checked;
    if (checked) {
      if(max && value.length >= max) {
        evt.target.checked = false;
        addNotification({
          position: 'bottom-right',
          text: `Cannot select more than ${max} options`,
          type: 'warning',
          removeAfter: 2000,
        })
        return;
      }
      value = [...value, option];
    } else {
      value = value.filter((v) => v !== option);
    }

    dispatch('change', value)
  }
</script>

<Label>{label}</Label>
{#each options as opt}
  <Input
    on:change={e => onChange(e, opt)} checked={value.includes(opt)}
    class="clickable" type="switch" label={opt}
  />
{/each}
